// File: SocketServer.java
// TCP/IP threaded Java server example

import java.awt.Color;
import java.awt.BorderLayout;
import java.awt.event.*;
import javax.swing.*;

import java.io.*;
import java.net.*;

// ClientWorker is the thread that serves each client
class ClientWorker implements Runnable {
  private Socket client;
  IntegerObject CurrValue;
  
  ClientWorker(Socket client,IntegerObject Value) {
   this.client = client;
   CurrValue=Value;
   System.out.println("CurrValue:"+CurrValue);
  }

  public void run(){
    String line=null;
    BufferedReader in = null;
    PrintWriter out = null;
    // Set up streams
    try{
      in = new BufferedReader(new InputStreamReader(client.getInputStream()));
      out = new PrintWriter(client.getOutputStream(), true);
    } 
    catch (IOException e) {
      System.out.println("in or out failed");
      System.exit(-1);
    }
    // Communications
    try{
      line = in.readLine();
      //Send previous value back to client
      out.println(String.valueOf(CurrValue.getValue()));
    } 
    catch (IOException e) {
         System.out.println("Read failed");
    }
    // Update the Current Value
    CurrValue.setValue(Integer.parseInt(line));
  }
//  }
}


class SocketThrdServer {

   ServerSocket server = null;
   int port;
   IntegerObject CurrentValue;

   SocketThrdServer(){ //Begin Constructor
     CurrentValue=new IntegerObject();
   } //End Constructor

   public void listenSocket(int port)
   {// First, get a socket; use the port passed in
    try{
      server = new ServerSocket(port); 
    } 
    catch (IOException e) {
      System.out.println("Could not listen on port "+port);
      System.exit(-1);
    }
    // Handle service requests
    while(true){
      ClientWorker w;
      try{
	// accept() fires when a request comes in; blocks until then
        w = new ClientWorker(server.accept(),CurrentValue);
	// Set up a thread to handle this client's requests
        Thread t = new Thread(w);
	// execute the thread's run() method;
        t.start();    
	// then, back to wait for another client's request
      } 
      catch (IOException e) {
        System.out.println("Accept failed: Port #"+port);
        System.exit(-1);
      }
    }
  }

  protected void finalize(){
  //Objects created in run method are finalized when 
  //program terminates and thread exits
     try{
        server.close();
    } 
    catch (IOException e) {
        System.out.println("Could not close socket");
        System.exit(-1);
    }
  }

  public static void main(String[] args){
        SocketThrdServer frame = new SocketThrdServer();
        int port=15010;
        frame.listenSocket(port);
  }
}

